Index: gnu/usr.bin/perl/INSTALL
===================================================================
RCS file: /home/afresh1/OpenBSD-perl/OP/cvs/src/gnu/usr.bin/perl/INSTALL,v
diff -u -p -a -u -p -r1.33 INSTALL
--- gnu/usr.bin/perl/INSTALL	26 Dec 2025 22:14:12 -0000	1.33
+++ gnu/usr.bin/perl/INSTALL	29 Mar 2026 16:31:42 -0000
@@ -92,10 +92,10 @@ to F<pod/perldelta.pod> for more detaile
 
 =head3 Compatibility with earlier versions
 
-B<WARNING:> This version is not binary compatible with earlier versions
-of Perl.  If you have built extensions (i.e. modules that include C code)
-using an earlier version of Perl, you will need to rebuild and reinstall
-those extensions.
+B<WARNING:> This version is not binary compatible with versions of Perl
+earlier than 5.42.0.  If you have built extensions (i.e. modules that
+include C code) using an earlier version of Perl, you will need to
+rebuild and reinstall those extensions.
 
 Pure perl modules without XS or C code should continue to work fine
 without reinstallation.  See the discussion below on
@@ -751,7 +751,7 @@ The directories set up by Configure fall
 
 =item Directories for the perl distribution
 
-By default, Configure will use the following directories for 5.42.0.
+By default, Configure will use the following directories for 5.42.2.
 $version is the full perl version number, including subversion, e.g.
 5.12.3, and $archname is a string like sun4-sunos,
 determined by Configure.  The full definitions of all Configure
@@ -2575,8 +2575,8 @@ L<https://www.chiark.greenend.org.uk/~sg
 
 =head1 Coexistence with earlier versions of perl 5
 
-Perl 5.42.0 is not binary compatible with earlier versions of Perl.
-In other words, you will have to recompile your XS modules.
+Perl 5.42.2 is not binary compatible with versions of Perl earlier than
+5.42.0.  In other words, you will have to recompile your XS modules.
 
 In general, you can usually safely upgrade from one stable version of Perl
 (e.g. 5.30.0) to another similar minor version (e.g. 5.30.1) without
@@ -2650,9 +2650,9 @@ won't interfere with another version.  (
 libraries after 5.6.0, but not for executables. TODO?)  One convenient
 way to do this is by using a separate prefix for each version, such as
 
-	sh Configure -Dprefix=/opt/perl5.42.0
+	sh Configure -Dprefix=/opt/perl5.42.2
 
-and adding /opt/perl5.42.0/bin to the shell PATH variable.  Such users
+and adding /opt/perl5.42.2/bin to the shell PATH variable.  Such users
 may also wish to add a symbolic link /usr/local/bin/perl so that
 scripts can still start with #!/usr/local/bin/perl.
 
@@ -2665,13 +2665,13 @@ seriously consider using a separate dire
 subversions may not have all the compatibility wrinkles ironed out
 yet.
 
-=head2 Upgrading from 5.40.0 or earlier
+=head2 Upgrading from 5.41.13 or earlier
 
-B<Perl 5.42.0 may not be binary compatible with Perl 5.40.0 or
+B<Perl 5.42.2 may not be binary compatible with Perl 5.41.13 or
 earlier Perl releases.>  Perl modules having binary parts
 (meaning that a C compiler is used) will have to be recompiled to be
-used with 5.42.0.  If you find you do need to rebuild an extension with
-5.42.0, you may safely do so without disturbing the older
+used with 5.42.2.  If you find you do need to rebuild an extension with
+5.42.2, you may safely do so without disturbing the older
 installations.  (See L<"Coexistence with earlier versions of perl 5">
 above.)
 
@@ -2704,15 +2704,15 @@ Firstly, the bare minimum to run this sc
      print("$f\n");
   }
 
-in Linux with perl-5.42.0 is as follows (under $Config{prefix}):
+in Linux with perl-5.42.2 is as follows (under $Config{prefix}):
 
   ./bin/perl
-  ./lib/perl5/5.42.0/strict.pm
-  ./lib/perl5/5.42.0/warnings.pm
-  ./lib/perl5/5.42.0/i686-linux/File/Glob.pm
-  ./lib/perl5/5.42.0/feature.pm
-  ./lib/perl5/5.42.0/XSLoader.pm
-  ./lib/perl5/5.42.0/i686-linux/auto/File/Glob/Glob.so
+  ./lib/perl5/5.42.2/strict.pm
+  ./lib/perl5/5.42.2/warnings.pm
+  ./lib/perl5/5.42.2/i686-linux/File/Glob.pm
+  ./lib/perl5/5.42.2/feature.pm
+  ./lib/perl5/5.42.2/XSLoader.pm
+  ./lib/perl5/5.42.2/i686-linux/auto/File/Glob/Glob.so
 
 Secondly, for perl-5.10.1, the Debian perl-base package contains 591
 files, (of which 510 are for lib/unicore) totaling about 3.5MB in its
Index: gnu/usr.bin/perl/MANIFEST
===================================================================
RCS file: /home/afresh1/OpenBSD-perl/OP/cvs/src/gnu/usr.bin/perl/MANIFEST,v
diff -u -p -a -u -p -r1.78 MANIFEST
--- gnu/usr.bin/perl/MANIFEST	26 Dec 2025 22:16:21 -0000	1.78
+++ gnu/usr.bin/perl/MANIFEST	29 Mar 2026 16:31:42 -0000
@@ -6373,9 +6373,13 @@ pod/perl5381delta.pod			Perl changes in 
 pod/perl5382delta.pod			Perl changes in version 5.38.2
 pod/perl5383delta.pod			Perl changes in version 5.38.3
 pod/perl5384delta.pod			Perl changes in version 5.38.4
+pod/perl5385delta.pod			Perl changes in version 5.38.5
 pod/perl5400delta.pod			Perl changes in version 5.40.0
 pod/perl5401delta.pod			Perl changes in version 5.40.1
 pod/perl5402delta.pod			Perl changes in version 5.40.2
+pod/perl5403delta.pod			Perl changes in version 5.40.3
+pod/perl5420delta.pod			Perl changes in version 5.42.0
+pod/perl5421delta.pod			Perl changes in version 5.42.1
 pod/perl561delta.pod			Perl changes in version 5.6.1
 pod/perl56delta.pod			Perl changes in version 5.6
 pod/perl581delta.pod			Perl changes in version 5.8.1
@@ -6624,6 +6628,7 @@ t/class/construct.t			See if class const
 t/class/destruct.t			See if class destruction works
 t/class/field.t				See if class field declarations work
 t/class/gh22169.t			Test defining a class that previously failed to define
+t/class/gh23511.t			Test defining a reader after a strict 'vars' violation
 t/class/inherit.t			See if class inheritance works
 t/class/method.t			See if class method declarations work
 t/class/phasers.t			See if class phaser blocks work
Index: gnu/usr.bin/perl/Makefile.SH
===================================================================
RCS file: /home/afresh1/OpenBSD-perl/OP/cvs/src/gnu/usr.bin/perl/Makefile.SH,v
diff -u -p -a -u -p -r1.71 Makefile.SH
--- gnu/usr.bin/perl/Makefile.SH	26 Dec 2025 22:16:21 -0000	1.71
+++ gnu/usr.bin/perl/Makefile.SH	29 Mar 2026 16:31:42 -0000
@@ -636,7 +636,7 @@ esac
 
 $spitshell >>$Makefile <<'!NO!SUBS!'
 
-perltoc_pod_prereqs = extra.pods pod/perl5420delta.pod pod/perlapi.pod pod/perlintern.pod pod/perlmodlib.pod
+perltoc_pod_prereqs = extra.pods pod/perl5422delta.pod pod/perlapi.pod pod/perlintern.pod pod/perlmodlib.pod
 generated_pods = pod/perltoc.pod $(perltoc_pod_prereqs)
 generated_headers = uudmap.h bitcount.h mg_data.h
 
@@ -1143,9 +1143,9 @@ pod/perlintern.pod: $(MINIPERL_EXE) auto
 pod/perlmodlib.pod: $(MINIPERL_EXE) pod/perlmodlib.PL MANIFEST
 	$(MINIPERL) pod/perlmodlib.PL -q
 
-pod/perl5420delta.pod: pod/perldelta.pod
-	$(RMS) pod/perl5420delta.pod
-	$(LNS) perldelta.pod pod/perl5420delta.pod
+pod/perl5422delta.pod: pod/perldelta.pod
+	$(RMS) pod/perl5422delta.pod
+	$(LNS) perldelta.pod pod/perl5422delta.pod
 
 extra.pods: $(MINIPERL_EXE)
 	-@test ! -f extra.pods || rm -f `cat extra.pods`
Index: gnu/usr.bin/perl/Makefile.bsd-wrapper1
===================================================================
RCS file: /home/afresh1/OpenBSD-perl/OP/cvs/src/gnu/usr.bin/perl/Makefile.bsd-wrapper1,v
diff -u -p -a -u -p -r1.48 Makefile.bsd-wrapper1
--- gnu/usr.bin/perl/Makefile.bsd-wrapper1	26 Dec 2025 22:15:22 -0000	1.48
+++ gnu/usr.bin/perl/Makefile.bsd-wrapper1	29 Mar 2026 16:31:42 -0000
@@ -97,10 +97,14 @@ _quick3p=
     perl5382delta 1			pod/perl5382delta.pod \
     perl5383delta 1			pod/perl5383delta.pod \
     perl5384delta 1			pod/perl5384delta.pod \
+    perl5385delta 1			pod/perl5385delta.pod \
     perl5400delta 1			pod/perl5400delta.pod \
     perl5401delta 1			pod/perl5401delta.pod \
     perl5402delta 1			pod/perl5402delta.pod \
+    perl5403delta 1			pod/perl5403delta.pod \
     perl5420delta 1			pod/perl5420delta.pod \
+    perl5421delta 1			pod/perl5421delta.pod \
+    perl5422delta 1			pod/perl5422delta.pod \
     perl561delta 1			pod/perl561delta.pod \
     perl56delta 1			pod/perl56delta.pod \
     perl581delta 1			pod/perl581delta.pod \
Index: gnu/usr.bin/perl/README
===================================================================
RCS file: /home/afresh1/OpenBSD-perl/OP/cvs/src/gnu/usr.bin/perl/README,v
diff -u -p -a -u -p -r1.26 README
--- gnu/usr.bin/perl/README	26 Dec 2025 22:14:12 -0000	1.26
+++ gnu/usr.bin/perl/README	29 Mar 2026 16:31:42 -0000
@@ -1,4 +1,4 @@
-Perl is Copyright (C) 1993 - 2025 by Larry Wall and others.
+Perl is Copyright (C) 1993 - 2026 by Larry Wall and others.
 
 All rights reserved.
 
Index: gnu/usr.bin/perl/README.haiku
===================================================================
RCS file: /home/afresh1/OpenBSD-perl/OP/cvs/src/gnu/usr.bin/perl/README.haiku,v
diff -u -p -a -u -p -r1.17 README.haiku
--- gnu/usr.bin/perl/README.haiku	26 Dec 2025 22:14:12 -0000	1.17
+++ gnu/usr.bin/perl/README.haiku	29 Mar 2026 16:31:42 -0000
@@ -24,9 +24,9 @@ The build procedure is completely standa
 Make perl executable and create a symlink for libperl:
 
   chmod a+x /boot/common/bin/perl
-  cd /boot/common/lib; ln -s perl5/5.42.0/BePC-haiku/CORE/libperl.so .
+  cd /boot/common/lib; ln -s perl5/5.42.2/BePC-haiku/CORE/libperl.so .
 
-Replace C<5.42.0> with your respective version of Perl.
+Replace C<5.42.2> with your respective version of Perl.
 
 =head1 KNOWN PROBLEMS
 
Index: gnu/usr.bin/perl/README.macosx
===================================================================
RCS file: /home/afresh1/OpenBSD-perl/OP/cvs/src/gnu/usr.bin/perl/README.macosx,v
diff -u -p -a -u -p -r1.17 README.macosx
--- gnu/usr.bin/perl/README.macosx	26 Dec 2025 22:14:12 -0000	1.17
+++ gnu/usr.bin/perl/README.macosx	29 Mar 2026 16:31:42 -0000
@@ -12,9 +12,9 @@ perlmacosx - Perl under Mac OS X
 
 This document briefly describes Perl under Mac OS X.
 
-  curl -O https://www.cpan.org/src/perl-5.42.0.tar.gz
-  tar -xzf perl-5.42.0.tar.gz
-  cd perl-5.42.0
+  curl -O https://www.cpan.org/src/perl-5.42.2.tar.gz
+  tar -xzf perl-5.42.2.tar.gz
+  cd perl-5.42.2
   ./Configure -des -Dprefix=/usr/local/
   make
   make test
@@ -22,7 +22,7 @@ This document briefly describes Perl und
 
 =head1 DESCRIPTION
 
-The latest Perl release (5.42.0 as of this writing) builds without changes
+The latest Perl release (5.42.2 as of this writing) builds without changes
 under all versions of Mac OS X from 10.3 "Panther" onwards. 
 
 In order to build your own version of Perl you will need 'make',
Index: gnu/usr.bin/perl/README.os2
===================================================================
RCS file: /home/afresh1/OpenBSD-perl/OP/cvs/src/gnu/usr.bin/perl/README.os2,v
diff -u -p -a -u -p -r1.33 README.os2
--- gnu/usr.bin/perl/README.os2	26 Dec 2025 22:14:12 -0000	1.33
+++ gnu/usr.bin/perl/README.os2	29 Mar 2026 16:31:42 -0000
@@ -621,7 +621,7 @@ C<set PERLLIB_PREFIX> in F<Config.sys>, 
 
 =item Additional Perl modules
 
-  unzip perl_ste.zip -d f:/perllib/lib/site_perl/5.42.0/
+  unzip perl_ste.zip -d f:/perllib/lib/site_perl/5.42.2/
 
 Same remark as above applies.  Additionally, if this directory is not
 one of directories on @INC (and @INC is influenced by C<PERLLIB_PREFIX>), you
Index: gnu/usr.bin/perl/README.vms
===================================================================
RCS file: /home/afresh1/OpenBSD-perl/OP/cvs/src/gnu/usr.bin/perl/README.vms,v
diff -u -p -a -u -p -r1.34 README.vms
--- gnu/usr.bin/perl/README.vms	26 Dec 2025 22:14:12 -0000	1.34
+++ gnu/usr.bin/perl/README.vms	29 Mar 2026 16:31:42 -0000
@@ -139,11 +139,11 @@ You may need to set up a foreign symbol 
 choice.  Once you have done so, use a command like the following to
 unpack the archive:
 
-    vmstar -xvf perl-5^.42^.0.tar
+    vmstar -xvf perl-5^.42^.2.tar
 
 Then set default to the top-level source directory like so:
 
-    set default [.perl-5^.42^.0]
+    set default [.perl-5^.42^.2]
 
 and proceed with configuration as described in the next section.
 
Index: gnu/usr.bin/perl/class.c
===================================================================
RCS file: /home/afresh1/OpenBSD-perl/OP/cvs/src/gnu/usr.bin/perl/class.c,v
diff -u -p -a -u -p -r1.1.1.3 class.c
--- gnu/usr.bin/perl/class.c	26 Dec 2025 22:12:29 -0000	1.1.1.3
+++ gnu/usr.bin/perl/class.c	29 Mar 2026 16:31:42 -0000
@@ -1140,7 +1140,8 @@ apply_field_attribute_reader(pTHX_ PADNA
     OP *nameop = newSVOP(OP_CONST, 0, value);
 
     CV *cv = newATTRSUB(floor_ix, nameop, NULL, NULL, ops);
-    CvIsMETHOD_on(cv);
+    if (cv)
+        CvIsMETHOD_on(cv);
 }
 
 /* If '@_' is called "snail", then elements of it can be called "slugs"; i.e.
@@ -1238,7 +1239,8 @@ apply_field_attribute_writer(pTHX_ PADNA
     OP *nameop = newSVOP(OP_CONST, 0, value);
 
     CV *cv = newATTRSUB(floor_ix, nameop, NULL, NULL, ops);
-    CvIsMETHOD_on(cv);
+    if (cv)
+        CvIsMETHOD_on(cv);
 }
 
 static struct {
Index: gnu/usr.bin/perl/locale.c
===================================================================
RCS file: /home/afresh1/OpenBSD-perl/OP/cvs/src/gnu/usr.bin/perl/locale.c,v
diff -u -p -a -u -p -r1.13 locale.c
--- gnu/usr.bin/perl/locale.c	26 Dec 2025 22:14:12 -0000	1.13
+++ gnu/usr.bin/perl/locale.c	29 Mar 2026 16:31:45 -0000
@@ -8143,11 +8143,12 @@ S_maybe_override_codeset(pTHX_ const cha
 
 /*
 =for apidoc_section $time
-=for apidoc      sv_strftime_tm
-=for apidoc_item sv_strftime_ints
+=for apidoc      sv_strftime_ints
+=for apidoc_item sv_strftime_tm
 =for apidoc_item my_strftime
 
-These implement the libc strftime().
+These implement libc strftime(), overcoming various deficiencies it has; you
+will come to regret sooner or later using it directly instead of these.
 
 On failure, they return NULL, and set C<errno> to C<EINVAL>.
 
@@ -8156,70 +8157,154 @@ handle the UTF-8ness of the current loca
 result.  Only if the current C<LC_TIME> locale is a UTF-8 one (and S<C<use
 bytes>> is not in effect) will the result be marked as UTF-8.
 
+For these, the caller assumes ownership of the returned SV with a reference
+count of 1.
+
 C<my_strftime> is kept for backwards compatibility.  Knowing if its result
 should be considered UTF-8 or not requires significant extra logic.
 
 Note that all three functions are always executed in the underlying
 C<LC_TIME> locale of the program, giving results based on that locale.
 
-The functions differ as follows:
+The stringified C<fmt> parameter in all is the same as the system libc
+C<strftime>.  The available conversion specifications vary by platform.  These
+days, every specification listed in the ANSI C99 standard should be usable
+everywhere.  These are C<a A b B c d H I j m M p S U w W x X y Y Z %>. 
+
+But note that the B<results> of some of the conversion specifiers are
+non-portable.  For example, the specifiers C<a A b B c p Z> change according
+to the locale settings of the user, and both how to set locales (the
+locale names) and what output to expect are not standardized.
+The specifier C<c> changes according to the timezone settings of the
+user and the timezone computation rules of the operating system.
+The C<Z> specifier is notoriously unportable since the names of
+timezones are not standardized. Sticking to the numeric specifiers is the
+safest route.
 
-C<sv_strftime_tm> takes a pointer to a filled-in S<C<struct tm>> parameter.  It
-ignores the values of the C<wday> and C<yday> fields in it.  The other fields
-give enough information to accurately calculate these values, and are used for
-that purpose.
-
-The caller assumes ownership of the returned SV with a reference count of 1.
-
-C<sv_strftime_ints> takes a bunch of integer parameters that together
-completely define a given time.  It calculates the S<C<struct tm>> to pass to
-libc strftime(), and calls that function.
+At the time of this writing, for example, C<%s> is not available on
+Windows-like systems.
 
-The value of C<isdst> is used as follows:
+The functions differ as follows:
 
 =over
 
-=item 0
+=item *
+
+The C<fmt> parameter and the return from C<my_strftime> are S<C<char *>>
+instead of the S<C<SV *>> in the other two functions.  This means the
+UTF-8ness of the format and result are unspecified.  The result MUST be
+arranged to be FREED BY THE CALLER).
 
-No daylight savings time is in effect
+=item *
 
-=item E<gt>0
+C<sv_strftime_ints> and C<my_strftime> take a bunch of integer parameters that
+together completely define a given time.  They calculate the S<C<struct tm>>
+to pass to libc strftime(), and call that function.  See below for the meaning
+of the parameters.
 
-Check if daylight savings time is in effect, and adjust the results
-accordingly.
+C<sv_strftime_tm> takes a pointer to an already filled-in S<C<struct tm>>
+parameter, so avoids that calculation.
 
-=item E<lt>0
+=item *
 
-This value is reserved for internal use by the L<POSIX> module for backwards
-compatibility purposes.
+C<my_strftime> takes two extra parameters that are ignored, being kept only
+for historical reasons.  These are C<wday> and C<yday>.
 
 =back
 
-The caller assumes ownership of the returned SV with a reference count of 1.
+The C99 Standard calls for S<C<struct tm>> to contain at least these fields:
 
-C<my_strftime> is like C<sv_strftime_ints> except that:
+ int tm_sec;    // seconds after the minute — [0, 60]
+ int tm_min;    // minutes after the hour — [0, 59]
+ int tm_hour;   // hours since midnight — [0, 23]
+ int tm_mday;   // day of the month — [1, 31]
+ int tm_mon;    // months since January — [0, 11]
+ int tm_year;   // years since 1900
+ int tm_wday;   // days since Sunday — [0, 6]
+ int tm_yday;   // days since January 1 — [0, 365]
+ int tm_isdst;  // Daylight Saving Time flag
+
+C<tm_wday> and C<tm_yday> are output only; the other fields give enough
+information to accurately calculate these, and are internally used for that
+purpose.
+
+The numbers enclosed in the square brackets above give the maximum legal
+ranges for values in the corresponding field.  Those ranges are restricted for
+some inputs. For example, not all months have 31 days, but all hours have 60
+minutes.  If you set a number that is outside the corresponding range, perl
+and the libc functions will automatically normalize it to be inside the range,
+adjusting other values as necessary.  For example, specifying February 29, is
+the same as saying March 1 for non-leap years; and using a minute value of 60
+will instead change that to a 0, and increment the hour, which in turn, if the
+hour was 23, will roll it over to 0 it and increment the day, and so on.
+
+Each parameter to C<sv_strftime_ints> and C<my_strftime> populates the
+similarly-named field in this structure.
+
+A value of 60 is legal for C<tm_sec>, but only for those moments when an
+official leap second has been declared.  It is undefined behavior to use them
+otherwise, and the behavior does vary depending on the implementation.
+Some implementations take your word for it that this is a leap second, leaving
+it as the 61st second of the given minute; some roll it over to be the 0th
+second of the following minute; some treat it as 0.  Some non-conforming
+implementations always roll it over to the next minute, regardless of whether
+an actual leap second is occurring or not.  (And yes, it is a real problem
+that different computers have a different conception of what the current time
+is; you can search the internet for details.)
+
+There is no limit (outside the size of C<int>) for the value of C<tm_year>,
+but sufficiently negative values (for earlier than 1900) may have different
+results on different systems and locales.  Some libc implementations may know
+when a given locale adopted the Greorian calendar, and adjust for that.
+Others will not.  (And some countries didn't adopt the Gregorian calendar
+until after 1900.)  Probably all implementations assume modern time zones go
+back forever, before they were actually invented, starting in the last half of
+the 19th century.
+
+The treatment of the C<isdst> field has varied over previous Perl versions,
+and has been buggy (both by perl and by some libc implementations), but is now
+aligned, as best we can, with the POSIX Standard, as follows:
 
 =over
 
-=item The C<fmt> parameter and the return are S<C<char *>> instead of
-S<C<SV *>>.
+=item C<is_dist> is 0
 
-This means the UTF-8ness of the result is unspecified.  The result MUST be
-arranged to be FREED BY THE CALLER).
+The function is to assume that daylight savings time is not in effect.  This
+should now always work properly, as perl uses its own implementation in this
+case, avoiding non-conforming libc ones.
 
-=item The C<is_dst> parameter is ignored.
+=item C<is_dist> is E<gt>0
 
-Daylight savings time is never considered to be in effect.
+The function is to assume that daylight savings time is in effect, though some
+underlying libc implementations treat this as a hint instead of a mandate.
 
-=item It has extra parameters C<yday> and C<wday> that are ignored.
+=item C<is_dist> is E<lt>0
 
-These exist only for historical reasons; the values for the corresponding
-fields in S<C<struct tm>> are calculated from the other arguments.
+The function is to itself try to calculate if daylight savings time is in
+effect.  More recent libc implementations are better at this than earlier
+ones.
 
 =back
 
-Note that all three functions are always executed in the underlying C<LC_TIME>
-locale of the program, giving results based on that locale.
+Some libc implementations have extra fields in S<C<struct tm>>.  The two that
+perl handles are:
+
+  int tm_gmtoff;            // Seconds East of UTC [%z]
+  const char * tm_zone;     // Timezone abbreviation [%Z]
+
+These are both output only.  Using the respective conversion specifications
+(enclosed in the square brackets) in the C<fmt> parameter is a portable way to
+gain access to these values, working both on systems that have and don't have
+these fields.
+
+Example, in the C<C> locale:
+
+ my_strftime( "%A, %B %d, %Y", 0, 0, 0, 12, 11, 95, 0, 0, -1 );
+
+returns
+
+ "Tuesday, December 12, 1995"
+
 =cut
  */
 
@@ -8231,7 +8316,6 @@ Perl_my_strftime(pTHX_ const char *fmt, 
     PERL_ARGS_ASSERT_MY_STRFTIME;
     PERL_UNUSED_ARG(wday);
     PERL_UNUSED_ARG(yday);
-    PERL_UNUSED_ARG(isdst);
 
 #ifdef USE_LOCALE_TIME
     const char * locale = querylocale_c(LC_TIME);
@@ -8240,7 +8324,7 @@ Perl_my_strftime(pTHX_ const char *fmt, 
 #endif
 
     struct tm  mytm;
-    ints_to_tm(&mytm, locale, sec, min, hour, mday, mon, year, 0);
+    ints_to_tm(&mytm, locale, sec, min, hour, mday, mon, year, isdst);
     if (! strftime_tm(fmt, PL_scratch_langinfo, locale, &mytm)) {
         return NULL;
     }
@@ -8260,15 +8344,8 @@ Perl_sv_strftime_ints(pTHX_ SV * fmt, in
     const char * locale = "C";
 #endif
 
-    /* A negative 'isdst' triggers backwards compatibility mode for
-     * POSIX::strftime(), in which 0 is always passed to ints_to_tm() so that
-     * the possibility of daylight savings time is never considered,  But, a 1
-     * is eventually passed to libc strftime() so that it returns the results
-     * it always has for a non-zero 'isdst'.  See GH #22351 */
     struct tm  mytm;
-    ints_to_tm(&mytm, locale, sec, min, hour, mday, mon, year,
-                              MAX(0, isdst));
-    mytm.tm_isdst = MIN(1, abs(isdst));
+    ints_to_tm(&mytm, locale, sec, min, hour, mday, mon, year, isdst);
     return sv_strftime_common(fmt, locale, &mytm);
 }
 
@@ -8352,20 +8429,22 @@ S_ints_to_tm(pTHX_ struct tm * mytm,
     mytm->tm_year = year;
 
     struct tm * which_tm = mytm;
-    struct tm aux_tm;
 
 #ifndef HAS_MKTIME
 
     mini_mktime(mytm);
 
 #else
+#  if defined(HAS_TM_TM_GMTOFF) || defined(HAS_TM_TM_ZONE)
+#    define ALWAYS_RUN_MKTIME
+
+    struct tm aux_tm;
+
+#  endif
 
     /* On platforms that have either of these two fields, we have to run the
      * libc mktime() in order to set them, as mini_mktime() doesn't deal with
      * them.  [perl #18238] */
-#  if defined(HAS_TM_TM_GMTOFF) || defined(HAS_TM_TM_ZONE)
-#    define ALWAYS_RUN_MKTIME
-#  endif
 
     /* When isdst is 0, it means to consider daylight savings time as never
      * being in effect.  Many libc implementations of mktime() do not allow
@@ -8374,44 +8453,52 @@ S_ints_to_tm(pTHX_ struct tm * mytm,
     if (isdst == 0) {
         mini_mktime(mytm);
 
-#  ifndef ALWAYS_RUN_MKTIME
-
-    /* When we don't always need libc mktime(), we call it only when we didn't
-     * call mini_mktime() */
-    } else {
+#  ifdef ALWAYS_RUN_MKTIME
 
-#  else
         /* Here will have to run libc mktime() in order to get the values of
          * some fields that mini_mktime doesn't populate.  We don't want
-         * mktime's side effect of looking for dst, so we have to have a
-         * separate tm structure from which we copy just those fields into the
-         * returned structure.  Initialize its values.  mytm should now be a
-         * normalized version of the input. */
+         * mktime's side effect of looking for dst (because isdst==0), so we
+         * have to have a separate tm structure from which we copy just those
+         * fields into the structure we return.  Initialize its values, which
+         * have now been normalized by mini_mktime. */
         aux_tm = *mytm;
-        aux_tm.tm_isdst = isdst;
         which_tm = &aux_tm;
 
 #  endif
 
+    }
+
+#  ifndef ALWAYS_RUN_MKTIME
+
+    else {  /* Don't run libc mktime if both:
+                1) we ran mini_mktime above; and
+                2) we don't have to always run libc mktime */
+
+#  endif
+
         /* Here, we need to run libc mktime(), either because we want to take
          * dst into consideration, or because it calculates one or two fields
-         * that we need that mini_mktime() doesn't handle.
-         *
-         * Unlike mini_mktime(), it does consider the locale, so have to switch
+         * that we need that mini_mktime() doesn't handle. */
+        which_tm->tm_isdst = isdst;
+
+        /* Unlike mini_mktime(), it does consider the locale, so have to switch
          * to the correct one. */
         const char * orig_TIME_locale = toggle_locale_c(LC_TIME, locale);
         MKTIME_LOCK;
 
-        /* which_tm points to an auxiliary copy if we ran mini_mktime().
+        /* 'which_tm' points to an auxiliary copy if we ran mini_mktime().
          * Otherwise it points to the passed-in one which now gets populated
          * directly. */
         (void) mktime(which_tm);
 
         MKTIME_UNLOCK;
         restore_toggled_locale_c(LC_TIME, orig_TIME_locale);
+
+#  ifndef ALWAYS_RUN_MKTIME
+
     }
 
-#  if defined(HAS_TM_TM_GMTOFF) || defined(HAS_TM_TM_ZONE)
+#  else
 
     /* And use the saved libc values for tm_gmtoff and tm_zone if we used an
      * auxiliary struct to get them */
Index: gnu/usr.bin/perl/op.c
===================================================================
RCS file: /home/afresh1/OpenBSD-perl/OP/cvs/src/gnu/usr.bin/perl/op.c,v
diff -u -p -a -u -p -r1.32 op.c
--- gnu/usr.bin/perl/op.c	10 Jan 2026 23:20:43 -0000	1.32
+++ gnu/usr.bin/perl/op.c	29 Mar 2026 16:31:45 -0000
@@ -3756,7 +3756,13 @@ Perl_doref(pTHX_ OP *o, I32 type, bool s
             break;
 
         case OP_COND_EXPR:
+            /* OP_COND_EXPR is the only op where we have to propagate
+             * context to *both* branches. Recurse on the first branch,
+             * then iterate on the second branch.
+             */
             o = OpSIBLING(cUNOPo->op_first);
+            doref(o, type, set_op_ref);
+            o = OpSIBLING(o);
             continue;
 
         case OP_RV2SV:
@@ -3829,22 +3835,12 @@ Perl_doref(pTHX_ OP *o, I32 type, bool s
             break;
         } /* switch */
 
-        while (1) {
-            if (o == top_op)
-                return scalar(top_op); /* at top; no parents/siblings to try */
-            if (OpHAS_SIBLING(o)) {
-                o = o->op_sibparent;
-                /* Normally skip all siblings and go straight to the parent;
-                 * the only op that requires two children to be processed
-                 * is OP_COND_EXPR */
-                if (!OpHAS_SIBLING(o)
-                        && o->op_sibparent->op_type == OP_COND_EXPR)
-                    break;
-                continue;
-            }
-            o = o->op_sibparent; /* try parent's next sibling */
-        }
+        /* whole tree has been scanned for ref stuff; now propagate
+         * scalar context */
+        return scalar(top_op);
+
     } /* while */
+
 }
 
 
@@ -8341,6 +8337,7 @@ Perl_utilize(pTHX_ int aver, I32 floor, 
         else {
             PL_hints &= ~HINT_ASCII_ENCODING;
         }
+        notify_parser_that_encoding_changed();
 
         PL_prevailing_version = shortver;
     }
Index: gnu/usr.bin/perl/patchlevel.h
===================================================================
RCS file: /home/afresh1/OpenBSD-perl/OP/cvs/src/gnu/usr.bin/perl/patchlevel.h,v
diff -u -p -a -u -p -r1.57 patchlevel.h
--- gnu/usr.bin/perl/patchlevel.h	26 Dec 2025 22:14:12 -0000	1.57
+++ gnu/usr.bin/perl/patchlevel.h	29 Mar 2026 16:31:45 -0000
@@ -39,7 +39,7 @@ Instead use one of the version compariso
 
 #define PERL_REVISION	5		/* age */
 #define PERL_VERSION	42		/* epoch */
-#define PERL_SUBVERSION	0		/* generation */
+#define PERL_SUBVERSION	2		/* generation */
 
 /* The following numbers describe the earliest compatible version of
    Perl ("compatibility" here being defined as sufficient binary/API
Index: gnu/usr.bin/perl/perl.c
===================================================================
RCS file: /home/afresh1/OpenBSD-perl/OP/cvs/src/gnu/usr.bin/perl/perl.c,v
diff -u -p -a -u -p -r1.51 perl.c
--- gnu/usr.bin/perl/perl.c	26 Dec 2025 22:15:22 -0000	1.51
+++ gnu/usr.bin/perl/perl.c	29 Mar 2026 16:31:45 -0000
@@ -4,7 +4,7 @@
  *    Copyright (C) 1993, 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001
  *    2002, 2003, 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011, 2012
  *    2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020, 2021, 2022, 2023
- *    2024, 2025
+ *    2024, 2025, 2026
  *    by Larry Wall and others
  *
  *    You may distribute under the terms of either the GNU General Public
@@ -4030,7 +4030,7 @@ S_minus_v(pTHX)
 #endif
 
         PerlIO_printf(PIO_stdout,
-		      "\n\nCopyright 1987-2025, Larry Wall\n");
+		      "\n\nCopyright 1987-2026, Larry Wall\n");
 #ifdef OS2
         PerlIO_printf(PIO_stdout,
                       "\n\nOS/2 port Copyright (c) 1990, 1991, Raymond Chen, Kai Uwe Rommel\n"
